diff --git a/lustre/ldlm/ldlm_lockd.c b/lustre/ldlm/ldlm_lockd.c
index cf7a5b0..37b9b2c 100644
--- a/lustre/ldlm/ldlm_lockd.c
+++ b/lustre/ldlm/ldlm_lockd.c
@@ -85,8 +85,21 @@ static inline unsigned int ldlm_get_rq_timeout(void)
 }
 
 #ifdef __KERNEL__
-/* w_l_spinlock protects both waiting_locks_list and expired_lock_thread */
-static cfs_spinlock_t waiting_locks_spinlock;   /* BH lock (timer) */
+/**
+ * Protects both waiting_locks_list and expired_lock_thread
+ */
+static cfs_spinlock_t waiting_locks_spinlock;
+
+/**
+ * List for contended locks.
+ *
+ * As soon as a lock is contended, it gets placed on this list and expected
+ * time to get a response is filled in the lock.
+ * Special thread walks the list looking for locks that should be released
+ * and schedules client evictions for those that have not been released in time.
+ *
+ * All access to it should be under waiting_locks_spinlock.
+ */
 static cfs_list_t waiting_locks_list;
 static cfs_timer_t waiting_locks_timer;
 
@@ -149,6 +162,9 @@ static inline int have_expired_locks(void)
         RETURN(need_to_run);
 }
 
+/**
+ * Check expired lock list for expired locks and time out them.
+ */
 static int expired_lock_main(void *arg)
 {
         cfs_list_t *expired = &expired_lock_thread.elt_expired_locks;
@@ -375,7 +391,9 @@ repeat:
         cfs_spin_unlock_bh(&waiting_locks_spinlock);
 }
 
-/*
+/**
+ * Add lock to the list of contended locks.
+ *
  * Indicate that we're waiting for a client to call us back cancelling a given
  * lock.  We add it to the pending-callback chain, and schedule the lock-timeout
  * timer to fire appropriately.  (We round up to the next second, to avoid
@@ -447,7 +465,7 @@ static int ldlm_add_waiting_lock(struct ldlm_lock *lock)
         return ret;
 }
 
-/*
+/**
  * Remove a lock from the pending list, likely because it had its cancellation
  * callback arrive without incident.  This adjusts the lock-timeout timer if
  * needed.  Returns 0 if the lock wasn't pending after all, 1 if it was.
@@ -504,8 +522,8 @@ int ldlm_del_waiting_lock(struct ldlm_lock *lock)
         return ret;
 }
 
-/*
- * Prolong the lock
+/**
+ * Prolong the contended lock waiting time.
  *
  * Called with namespace lock held.
  */
@@ -553,6 +571,10 @@ int ldlm_refresh_waiting_lock(struct ldlm_lock *lock, int timeout)
 }
 #endif /* __KERNEL__ */
 
+/**
+ * Perform lock cleanup if AST sending failed.
+ *
+ */
 static void ldlm_failed_ast(struct ldlm_lock *lock, int rc,
                             const char *ast_type)
 {
@@ -578,6 +600,9 @@ static void ldlm_failed_ast(struct ldlm_lock *lock, int rc,
 #endif
 }
 
+/**
+ * Perform lock cleanup if AST reply came with error.
+ */
 static int ldlm_handle_ast_error(struct ldlm_lock *lock,
                                  struct ptlrpc_request *req, int rc,
                                  const char *ast_type)
@@ -704,7 +729,7 @@ static void ldlm_lock_reorder_req(struct ldlm_lock *lock)
         EXIT;
 }
 
-/*
+/**
  * ->l_blocking_ast() method for server-side locks. This is invoked when newly
  * enqueued server lock conflicts with given one.
  *
@@ -798,6 +823,14 @@ int ldlm_server_blocking_ast(struct ldlm_lock *lock,
         RETURN(rc);
 }
 
+/**
+ * ->l_completion_ast callback for a remote lockin server namespace
+ *
+ *  Sends AST to the client notifying it of lock granting.
+ *  If initial lock response was not sent yet, instead of sending another RPC,
+ *  just mark the lock as granted and client will understand
+ *
+ */
 int ldlm_server_completion_ast(struct ldlm_lock *lock, int flags, void *data)
 {
         struct ldlm_cb_set_arg *arg = data;
@@ -909,6 +942,12 @@ int ldlm_server_completion_ast(struct ldlm_lock *lock, int flags, void *data)
         RETURN(rc);
 }
 
+/**
+ * Server side ->l_glimpse_ast handler for client locks.
+ *
+ * Sends glimpse AST to the client and waits for reply. Then updates
+ * lvbo with the result.
+ */
 int ldlm_server_glimpse_ast(struct ldlm_lock *lock, void *data)
 {
         struct ldlm_resource  *res = lock->l_resource;
@@ -1003,9 +1042,9 @@ static void ldlm_svc_get_eopc(const struct ldlm_request *dlm_req,
         return;
 }
 
-/*
- * Main server-side entry point into LDLM. This is called by ptlrpc service
- * threads to carry out client lock enqueueing requests.
+/**
+ * Main server-side entry point into LDLM for enqueue. This is called by ptlrpc
+ * service threads to carry out client lock enqueueing requests.
  */
 int ldlm_handle_enqueue0(struct ldlm_namespace *ns,
                          struct ptlrpc_request *req,
@@ -1265,6 +1304,9 @@ existing_lock:
         return rc;
 }
 
+/**
+ * Old-style LDLM main entry point for server code enqueue.
+ */
 int ldlm_handle_enqueue(struct ptlrpc_request *req,
                         ldlm_completion_callback completion_callback,
                         ldlm_blocking_callback blocking_callback,
@@ -1288,6 +1330,9 @@ int ldlm_handle_enqueue(struct ptlrpc_request *req,
         return rc;
 }
 
+/**
+ * Main LDLM entry point for server code for lock conversion requests.
+ */
 int ldlm_handle_convert0(struct ptlrpc_request *req,
                          const struct ldlm_request *dlm_req)
 {
@@ -1339,6 +1384,9 @@ int ldlm_handle_convert0(struct ptlrpc_request *req,
         RETURN(0);
 }
 
+/**
+ * Old-style main LDLM entry for server code for lock conversion requests.
+ */
 int ldlm_handle_convert(struct ptlrpc_request *req)
 {
         int rc;
@@ -1354,7 +1402,12 @@ int ldlm_handle_convert(struct ptlrpc_request *req)
         return rc;
 }
 
-/* Cancel all the locks whos handles are packed into ldlm_request */
+/**
+ * Cancel all the locks whose handles are packed into ldlm_request
+ *
+ * Called by server code expecting such combined cancel activity
+ * requests.
+ */
 int ldlm_request_cancel(struct ptlrpc_request *req,
                         const struct ldlm_request *dlm_req, int first)
 {
@@ -1387,6 +1440,10 @@ int ldlm_request_cancel(struct ptlrpc_request *req,
                 res = lock->l_resource;
                 done++;
 
+                /* This code here is an optimisation to only attempt lock
+                 * granting on the resource (that could be cpu-expensive)
+                 * after we are done cancelling lock in that resource.
+                 */
                 if (res != pres) {
                         if (pres != NULL) {
                                 ldlm_reprocess_all(pres);
@@ -1412,6 +1469,11 @@ int ldlm_request_cancel(struct ptlrpc_request *req,
         RETURN(done);
 }
 
+/**
+ * Main LDLM entry point for server code to cancel locks.
+ *
+ * Typically gets called from service handler on LDLM_CANCEL opc.
+ */
 int ldlm_handle_cancel(struct ptlrpc_request *req)
 {
         struct ldlm_request *dlm_req;
@@ -1442,6 +1504,11 @@ int ldlm_handle_cancel(struct ptlrpc_request *req)
         RETURN(0);
 }
 
+/**
+ * Callback handler for receiving incoming blocking ASTs.
+ *
+ * This can only happen on client side.
+ */
 void ldlm_handle_bl_callback(struct ldlm_namespace *ns,
                              struct ldlm_lock_desc *ld, struct ldlm_lock *lock)
 {
@@ -1475,6 +1542,11 @@ void ldlm_handle_bl_callback(struct ldlm_namespace *ns,
         EXIT;
 }
 
+/**
+ * Callback handler for receiving incoming completion ASTs.
+ *
+ * This only can happen on client side.
+ */
 static void ldlm_handle_cp_callback(struct ptlrpc_request *req,
                                     struct ldlm_namespace *ns,
                                     struct ldlm_request *dlm_req,
@@ -1569,6 +1641,13 @@ static void ldlm_handle_cp_callback(struct ptlrpc_request *req,
         EXIT;
 }
 
+/**
+ * Callback handler for receiving incoming glimpse ASTs.
+ *
+ * This only can happen on client side.
+ * After handling the glimpse AST we also consider to drop the lock here if it
+ * is unused locally for a long time.
+ */
 static void ldlm_handle_gl_callback(struct ptlrpc_request *req,
                                     struct ldlm_namespace *ns,
                                     struct ldlm_request *dlm_req,
@@ -1622,6 +1701,16 @@ static int ldlm_callback_reply(struct ptlrpc_request *req, int rc)
 }
 
 #ifdef __KERNEL__
+/**
+ * This function queues a list of locks \param cancels containing \param count
+ * locks for later processing by a blocking thread.
+ * If \param count is zero, then the lock referenced as \param lock is
+ * queued instead.
+ *
+ * The blocking thread would then call ->l_blocking_ast callback in the lock.
+ * If list addition is failed, an error is returned and caller is supposed to
+ * call ->l_blocking_ast itself.
+ */
 static int ldlm_bl_to_thread(struct ldlm_namespace *ns,
                              struct ldlm_lock_desc *ld, struct ldlm_lock *lock,
                              cfs_list_t *cancels, int count)
@@ -1949,6 +2038,11 @@ static int ldlm_callback_handler(struct ptlrpc_request *req)
         RETURN(0);
 }
 
+/**
+ * Main handler for canceld thread.
+ *
+ * Separated into its own thread to avaod deadlocks.
+ */
 static int ldlm_cancel_handler(struct ptlrpc_request *req)
 {
         int rc;
@@ -2118,6 +2212,13 @@ static int ldlm_bl_thread_start(struct ldlm_bl_pool *blp)
         return 0;
 }
 
+/**
+ * Main blocking requests processing thread.
+ *
+ * Callers put locks into its queue by calling ldlm_bl_to_thread.
+ * This thread in the end ends up doing actial call to ->l_blocking_ast
+ * for queued locks.
+ */
 static int ldlm_bl_thread_main(void *arg)
 {
         struct ldlm_bl_pool *blp;
diff --git a/lustre/ldlm/ldlm_plain.c b/lustre/ldlm/ldlm_plain.c
index 5240a32..cd41d46 100644
--- a/lustre/ldlm/ldlm_plain.c
+++ b/lustre/ldlm/ldlm_plain.c
@@ -51,6 +51,15 @@
 
 #include "ldlm_internal.h"
 
+/**
+ * Determine if the lock is compatible with all locks on the queue.
+ *
+ * If \param work_list is provided, conflicting locks are linked there.
+ * If \param work_list is not provided, we exit this function on first conflict.
+ *
+ * \retval 0 if there are conflicting locks in the \param queue
+ * \retval 1 if the lock is compatible to all locks in \param queue
+ */
 static inline int
 ldlm_plain_compat_queue(cfs_list_t *queue, struct ldlm_lock *req,
                         cfs_list_t *work_list)
@@ -66,6 +75,11 @@ ldlm_plain_compat_queue(cfs_list_t *queue, struct ldlm_lock *req,
         cfs_list_for_each(tmp, queue) {
                 lock = cfs_list_entry(tmp, struct ldlm_lock, l_res_link);
 
+                /**
+                 * We stop walking the queue if we hit ourselves so we don't
+                 * take conflicting locks enqueued after us into account,
+                 * or we'd wait forever.
+                 */
                 if (req == lock)
                         RETURN(compat);
 
@@ -101,13 +115,21 @@ ldlm_plain_compat_queue(cfs_list_t *queue, struct ldlm_lock *req,
         RETURN(compat);
 }
 
-/* If first_enq is 0 (ie, called from ldlm_reprocess_queue):
+/**
+ * Process a granting attempt for plain lock.
+ * Must be called under ns lock held.
+ *
+ * This function tries to see if there are any conflicts for \a lock in
+ * any of the granted or waiting queues. If no conflict met in both,
+ * the lock is granted.
+ *
+ * If \a first_enq is 0 (ie, called from ldlm_reprocess_queue):
  *   - blocking ASTs have already been sent
- *   - must call this function with the resource lock held
  *
- * If first_enq is 1 (ie, called from ldlm_lock_enqueue):
- *   - blocking ASTs have not been sent
- *   - must call this function with the resource lock held */
+ * If \a first_enq is 1 (ie, called from ldlm_lock_enqueue):
+ *   - blocking ASTs have not been sent yet, so list of conflicting locks
+ *     would be collected and ASTs sent.
+ */
 int ldlm_process_plain_lock(struct ldlm_lock *lock, int *flags, int first_enq,
                             ldlm_error_t *err, cfs_list_t *work_list)
 {
diff --git a/lustre/ldlm/ldlm_request.c b/lustre/ldlm/ldlm_request.c
index f287f1a..59612b6 100644
--- a/lustre/ldlm/ldlm_request.c
+++ b/lustre/ldlm/ldlm_request.c
@@ -175,7 +175,7 @@ int ldlm_completion_ast_async(struct ldlm_lock *lock, int flags, void *data)
 }
 
 /**
- * Client side LDLM "completion" AST. This is called in several cases:
+ * Generic LDLM "completion" AST. This is called in several cases:
  *
  *     - when a reply to an ENQUEUE rpc is received from the server
  *       (ldlm_cli_enqueue_fini()). Lock might be granted or not granted at
@@ -344,7 +344,7 @@ int ldlm_blocking_ast(struct ldlm_lock *lock, struct ldlm_lock_desc *desc,
         RETURN(ldlm_blocking_ast_nocheck(lock));
 }
 
-/*
+/**
  * ->l_glimpse_ast() for DLM extent locks acquired on the server-side. See
  * comment in filter_intent_policy() on why you may need this.
  */
@@ -371,6 +371,9 @@ int ldlm_glimpse_ast(struct ldlm_lock *lock, void *reqp)
         return -ELDLM_NO_LOCK_DATA;
 }
 
+/**
+ * Enqueue a local lock (typically on a server).
+ */
 int ldlm_cli_enqueue_local(struct ldlm_namespace *ns,
                            const struct ldlm_res_id *res_id,
                            ldlm_type_t type, ldlm_policy_data_t *policy,
@@ -474,6 +477,11 @@ static void failed_lock_cleanup(struct ldlm_namespace *ns,
         }
 }
 
+/**
+ * Finishing portion of client lock enqueue code.
+ *
+ * Called after receiving reply from server.
+ */
 int ldlm_cli_enqueue_fini(struct obd_export *exp, struct ptlrpc_request *req,
                           ldlm_type_t type, __u8 with_policy, ldlm_mode_t mode,
                           int *flags, void *lvb, __u32 lvb_len,
@@ -641,7 +649,9 @@ cleanup:
         return rc;
 }
 
-/* PAGE_SIZE-512 is to allow TCP/IP and LNET headers to fit into
+/**
+ * Estimate number of loc handles that would fit into request of given size.
+ * PAGE_SIZE-512 is to allow TCP/IP and LNET headers to fit into
  * a single page on the send/receive side. XXX: 512 should be changed
  * to more adequate value. */
 static inline int ldlm_req_handles_avail(int req_size, int off)
@@ -674,8 +684,13 @@ static inline int ldlm_format_handles_avail(struct obd_import *imp,
         return ldlm_req_handles_avail(size, off);
 }
 
-/* Cancel lru locks and pack them into the enqueue request. Pack there the given
- * @count locks in @cancels. */
+/**
+ * Cancel lru locks and pack them into the enqueue request. Pack there the given
+ * \param count locks in \param cancels.
+ *
+ * This is to be called by functions preparing their own requests that
+ * might contain lists of locks to cancel in addition to actual operation
+ * that needs to be performed. */
 int ldlm_prep_elc_req(struct obd_export *exp, struct ptlrpc_request *req,
                       int version, int opc, int canceloff,
                       cfs_list_t *cancels, int count)
@@ -747,12 +762,16 @@ int ldlm_prep_enqueue_req(struct obd_export *exp, struct ptlrpc_request *req,
                                  LDLM_ENQUEUE_CANCEL_OFF, cancels, count);
 }
 
-/* If a request has some specific initialisation it is passed in @reqp,
+/**
+ * Client-side lock enqueue.
+ *
+ * If a request has some specific initialisation it is passed in @reqp,
  * otherwise it is created in ldlm_cli_enqueue.
  *
  * Supports sync and async requests, pass @async flag accordingly. If a
  * request was created in ldlm_cli_enqueue and it is the async request,
- * pass it to the caller in @reqp. */
+ * pass it to the caller in @reqp.
+ */
 int ldlm_cli_enqueue(struct obd_export *exp, struct ptlrpc_request **reqp,
                      struct ldlm_enqueue_info *einfo,
                      const struct ldlm_res_id *res_id,
@@ -994,11 +1013,13 @@ int ldlm_cli_convert(struct lustre_handle *lockh, int new_mode, __u32 *flags)
         return rc;
 }
 
-/* Cancel locks locally.
+/**
+ * Cancel locks locally.
  * Returns:
- * LDLM_FL_LOCAL_ONLY if tere is no need in a CANCEL rpc to the server;
- * LDLM_FL_CANCELING otherwise;
- * LDLM_FL_BL_AST if there is a need in a separate CANCEL rpc. */
+ * \retval LDLM_FL_LOCAL_ONLY if there is no need in a CANCEL rpc to the server;
+ * \retval LDLM_FL_CANCELING otherwise;
+ * \retval LDLM_FL_BL_AST if there is a need in a separate CANCEL rpc.
+ */
 static int ldlm_cli_cancel_local(struct ldlm_lock *lock)
 {
         int rc = LDLM_FL_LOCAL_ONLY;
@@ -1037,8 +1058,10 @@ static int ldlm_cli_cancel_local(struct ldlm_lock *lock)
         RETURN(rc);
 }
 
-/* Pack @count locks in @head into ldlm_request buffer at the offset @off,
-   of the request @req. */
+/**
+ * Pack \param count locks in \param head into ldlm_request buffer at
+ * the offset \param off, * of the request \param req.
+ */
 static void ldlm_cancel_pack(struct ptlrpc_request *req,
                              cfs_list_t *head, int count)
 {
@@ -1073,8 +1096,9 @@ static void ldlm_cancel_pack(struct ptlrpc_request *req,
         EXIT;
 }
 
-/* Prepare and send a batched cancel rpc, it will include count lock handles
- * of locks given in @head. */
+/**
+ * Prepare and send a batched cancel rpc, it will include \param count lock
+ * handles of locks given in \param cancels list. */
 int ldlm_cli_cancel_req(struct obd_export *exp, cfs_list_t *cancels,
                         int count, ldlm_cancel_flags_t flags)
 {
@@ -1169,7 +1193,8 @@ static inline struct ldlm_pool *ldlm_imp2pl(struct obd_import *imp)
 }
 
 /**
- * Update client's obd pool related fields with new SLV and Limit from \a req.
+ * Update client's obd pool related fields with new SLV and Limit from
+ * \param req.
  */
 int ldlm_cli_update_pool(struct ptlrpc_request *req)
 {
@@ -1223,6 +1248,11 @@ int ldlm_cli_update_pool(struct ptlrpc_request *req)
 }
 EXPORT_SYMBOL(ldlm_cli_update_pool);
 
+/**
+ * Client side lock cancel.
+ *
+ * Lock must not have any readers or writers by this time.
+ */
 int ldlm_cli_cancel(struct lustre_handle *lockh)
 {
         struct obd_export *exp;
@@ -1312,8 +1342,9 @@ static int ldlm_cancel_list(cfs_list_t *cancels, int count,
 
 /**
  * Callback function for lru-resize policy. Makes decision whether to keep
- * \a lock in LRU for current \a LRU size \a unused, added in current scan
- * \a added and number of locks to be preferably canceled \a count.
+ * \param lock in LRU for current \param LRU size \param unused, added in
+ * current scan \param added and number of locks to be preferably canceled
+ * \param count.
  *
  * \retval LDLM_POLICY_KEEP_LOCK keep lock in LRU in stop scanning
  *
@@ -1357,8 +1388,9 @@ static ldlm_policy_res_t ldlm_cancel_lrur_policy(struct ldlm_namespace *ns,
 
 /**
  * Callback function for proc used policy. Makes decision whether to keep
- * \a lock in LRU for current \a LRU size \a unused, added in current scan
- * \a added and number of locks to be preferably canceled \a count.
+ * \param lock in LRU for current \param LRU size \param unused, added in
+ * current scan \param added and number of locks to be preferably canceled
+ * \param count.
  *
  * \retval LDLM_POLICY_KEEP_LOCK keep lock in LRU in stop scanning
  *
@@ -1379,8 +1411,9 @@ static ldlm_policy_res_t ldlm_cancel_passed_policy(struct ldlm_namespace *ns,
 
 /**
  * Callback function for aged policy. Makes decision whether to keep
- * \a lock in LRU for current \a LRU size \a unused, added in current scan
- * \a added and number of locks to be preferably canceled \a count.
+ * \param lock in LRU for current \param LRU size \param unused, added in
+ * current scan \param added and number of locks to be preferably canceled
+ * \param count.
  *
  * \retval LDLM_POLICY_KEEP_LOCK keep lock in LRU in stop scanning
  *
@@ -1404,8 +1437,9 @@ static ldlm_policy_res_t ldlm_cancel_aged_policy(struct ldlm_namespace *ns,
 
 /**
  * Callback function for default policy. Makes decision whether to keep
- * \a lock in LRU for current \a LRU size \a unused, added in current scan
- * \a added and number of locks to be preferably canceled \a count.
+ * \param lock in LRU for current \param LRU size \param unused, added in
+ * current scan \param added and number of locks to be preferably canceled
+ * \param count.
  *
  * \retval LDLM_POLICY_KEEP_LOCK keep lock in LRU in stop scanning
  *
@@ -1447,11 +1481,12 @@ ldlm_cancel_lru_policy(struct ldlm_namespace *ns, int flags)
         return ldlm_cancel_default_policy;
 }
 
-/* - Free space in lru for @count new locks,
+/**
+ * - Free space in lru for \param count new locks,
  *   redundant unused locks are canceled locally;
  * - also cancel locally unused aged locks;
- * - do not cancel more than @max locks;
- * - GET the found locks and add them into the @cancels list.
+ * - do not cancel more than \param max locks;
+ * - GET the found locks and add them into the \param cancels list.
  *
  * A client lock can be added to the l_bl_ast list only when it is
  * marked LDLM_FL_CANCELING. Otherwise, somebody is already doing CANCEL.
@@ -1463,12 +1498,12 @@ ldlm_cancel_lru_policy(struct ldlm_namespace *ns, int flags)
  * Calling policies for enabled lru resize:
  * ----------------------------------------
  * flags & LDLM_CANCEL_LRUR - use lru resize policy (SLV from server) to
- *                            cancel not more than @count locks;
+ *                            cancel not more than \a count locks;
  *
- * flags & LDLM_CANCEL_PASSED - cancel @count number of old locks (located at
+ * flags & LDLM_CANCEL_PASSED - cancel \a count number of old locks (located at
  *                              the beginning of lru list);
  *
- * flags & LDLM_CANCEL_SHRINK - cancel not more than @count locks according to
+ * flags & LDLM_CANCEL_SHRINK - cancel not more than \a count locks according to
  *                              memory pressre policy function;
  *
  * flags & LDLM_CANCEL_AGED -   cancel alocks according to "aged policy".
@@ -1588,10 +1623,14 @@ int ldlm_cancel_lru_local(struct ldlm_namespace *ns, cfs_list_t *cancels,
         RETURN(ldlm_cancel_list(cancels, added, cancel_flags));
 }
 
-/* when called with LDLM_ASYNC the blocking callback will be handled
+/**
+ * Cancel at least \param nr locks from given namespace lru.
+ *
+ * when called with LDLM_ASYNC the blocking callback will be handled
  * in a thread and this function will return after the thread has been
  * asked to call the callback.  when called with LDLM_SYNC the blocking
- * callback will be performed in this function. */
+ * callback will be performed in this function.
+ */
 int ldlm_cancel_lru(struct ldlm_namespace *ns, int nr, ldlm_sync_t sync,
                     int flags)
 {
@@ -1615,9 +1654,11 @@ int ldlm_cancel_lru(struct ldlm_namespace *ns, int nr, ldlm_sync_t sync,
         RETURN(count);
 }
 
-/* Find and cancel locally unused locks found on resource, matched to the
- * given policy, mode. GET the found locks and add them into the @cancels
- * list. */
+/**
+ * Find and cancel locally unused locks found on resource, matched to the
+ * given policy, mode. GET the found locks and add them into the \param cancels
+ * list.
+ */
 int ldlm_cancel_resource_local(struct ldlm_resource *res,
                                cfs_list_t *cancels,
                                ldlm_policy_data_t *policy,
@@ -1670,12 +1711,16 @@ int ldlm_cancel_resource_local(struct ldlm_resource *res,
         RETURN(ldlm_cancel_list(cancels, count, cancel_flags));
 }
 
-/* If @req is NULL, send CANCEL request to server with handles of locks
- * in the @cancels. If EARLY_CANCEL is not supported, send CANCEL requests
+/**
+ * Cancel client-side locks from a list and send/prepare cancel RPCs to the
+ * server.
+ * If \param req is NULL, send CANCEL request to server with handles of locks
+ * in the \param cancels. If EARLY_CANCEL is not supported, send CANCEL requests
  * separately per lock.
- * If @req is not NULL, put handles of locks in @cancels into the request
- * buffer at the offset @off.
- * Destroy @cancels at the end. */
+ * If \param req is not NULL, put handles of locks in @cancels into the request
+ * buffer at the offset \param off.
+ * Destroy \param cancels at the end.
+ */
 int ldlm_cli_cancel_list(cfs_list_t *cancels, int count,
                          struct ptlrpc_request *req, ldlm_cancel_flags_t flags)
 {
@@ -1722,6 +1767,11 @@ int ldlm_cli_cancel_list(cfs_list_t *cancels, int count,
         RETURN(0);
 }
 
+/**
+ * Cancel all locks on a resource that have 0 readers/writers.
+ *
+ * If flags & LDLM_FL_LOCAL_ONLY, throw the locks away without trying
+ * to notify the server. */
 int ldlm_cli_cancel_unused_resource(struct ldlm_namespace *ns,
                                     const struct ldlm_res_id *res_id,
                                     ldlm_policy_data_t *policy,
@@ -1766,7 +1816,8 @@ static inline int have_no_nsresource(struct ldlm_namespace *ns)
         RETURN(no_resource);
 }
 
-/* Cancel all locks on a namespace (or a specific resource, if given)
+/**
+ * Cancel all locks on a namespace (or a specific resource, if given)
  * that have 0 readers/writers.
  *
  * If flags & LCF_LOCAL, throw the locks away without trying
